diff --git a/lib/hive/tui/bubble_model.rb b/lib/hive/tui/bubble_model.rb
index d42249e3..d7ad0041 100644
--- a/lib/hive/tui/bubble_model.rb
+++ b/lib/hive/tui/bubble_model.rb
@@ -3,6 +3,7 @@ require "date"
 require "digest"
 require "fileutils"
 require "set"
+require "securerandom"
 require "shellwords"
 require "stringio"
 require "time"
@@ -22,6 +23,7 @@ require "hive/tui/update"
 require "hive/tui/snapshot"
 require "hive/tui/text"
 require "hive/tui/log_tail"
+require "hive/tui/task_info"
 require "hive/tui/brainstorm_answers"
 require "hive/tui/clipboard"
 require "hive/tui/composer_staging"
@@ -32,7 +34,7 @@ require "hive/tui/views/log_tail"
 require "hive/tui/views/red_status_detail"
 require "hive/tui/views/help_overlay"
 require "hive/tui/views/filter_prompt"
-require "hive/tui/views/idea_preview"
+require "hive/tui/views/task_info"
 require "hive/tui/views/new_idea_prompt"
 require "hive/tui/views/new_idea_project_picker"
 
@@ -103,11 +105,13 @@ module Hive
       def initialize(
         hive_model: Hive::Tui::Model.initial,
         dispatch: ->(_msg) { },
-        clipboard_probe: ->(pasted_text:) { Hive::Tui::Clipboard.probe(pasted_text: pasted_text) }
+        clipboard_probe: ->(pasted_text:) { Hive::Tui::Clipboard.probe(pasted_text: pasted_text) },
+        task_info_loader: ->(folder) { Hive::Tui::TaskInfo.load(folder) }
       )
         @hive_model = hive_model
         @dispatch = dispatch
         @clipboard_probe = clipboard_probe
+        @task_info_loader = task_info_loader
         # `@healed_folders` is touched from the main runner thread
         # (`auto_heal_kill_class_errors` registers folders before
         # spawning heals) AND from heal Threads (which evict on
@@ -139,8 +143,13 @@ module Hive
         # first pass settles. Reuses @healed_folders_mutex so all
         # background-thread bookkeeping fields (@healed_folders,
         # @heal_threads, @review_recovery_inflight,
-        # @error_recovery_inflight) share a single lock.
+        # @error_recovery_inflight, @task_info_thread) share a single
+        # lock.
         @error_recovery_inflight = Set.new
+        # At most one task-info loader may be active. Closing the panel
+        # cancels it immediately; reopening defensively cancels any
+        # superseded worker that has not yet self-pruned.
+        @task_info_thread = nil
         # Once-per-session latch (reset in #stage_image on success).
         @clipboard_tool_hint_shown = false
         # Consecutive `wl-paste`/`xclip` timeouts: a single timeout
@@ -227,7 +236,7 @@ module Hive
         when :red_status_detail then Views::RedStatusDetail.render(@hive_model)
         when :help then Views::HelpOverlay.render(@hive_model)
         when :filter then compose_filter_view
-        when :idea_preview then compose_idea_preview_view
+        when :task_info then Views::TaskInfo.render(@hive_model)
         when :new_idea_project then compose_new_idea_project_view
         when :new_idea then compose_new_idea_view
         else compose_two_pane_view
@@ -384,8 +393,8 @@ module Hive
           open_input_editor(message.row)
         when Hive::Tui::Messages::OpenTaskFolder
           open_task_folder(message.row)
-        when Hive::Tui::Messages::OpenIdeaPreview
-          open_idea_preview(message.row)
+        when Hive::Tui::Messages::OpenTaskInfo
+          open_task_info(message)
         when Hive::Tui::Messages::OpenInAgent
           dispatch_open_in_agent_then_close_detail(message.row)
         when Hive::Tui::Messages::AgentSteerExited
@@ -400,6 +409,7 @@ module Hive
           # return nil so Update.apply still handles the mode flip
           # and tail_state clearing.
           close_tail_if_log_tail
+          cancel_task_info_thread if @hive_model.mode == :task_info
           nil
         when Hive::Tui::Messages::NewIdeaSubmitted
           submit_new_idea
@@ -1514,42 +1524,58 @@ module Hive
         [ flashed("editor command invalid: #{e.message}"), nil ]
       end
 
-      def open_idea_preview(row)
-        return [ flashed("no idea for #{row.slug}"), nil ] if row.folder.to_s.empty?
+      def open_task_info(message)
+        request_id = message.request_id || SecureRandom.uuid
+        open_message = Hive::Tui::Messages::OpenTaskInfo.new(row: message.row, request_id: request_id)
+        loading_model, = Hive::Tui::Update.apply(@hive_model, open_message)
+        unless cancel_task_info_thread
+          failed = Hive::Tui::Messages::TaskInfoFailed.new(
+            request_id: request_id,
+            error: "previous task info load is still stopping"
+          )
+          failed_model, = Hive::Tui::Update.apply(loading_model, failed)
+          return [ failed_model, nil ]
+        end
 
-        idea_path = File.join(row.folder, "idea.md")
-        return [ flashed("no idea.md for #{row.slug}"), nil ] unless File.exist?(idea_path)
+        spawn_task_info_thread(message.row, request_id)
+        [ loading_model, nil ]
+      end
 
-        data = idea_frontmatter(File.read(idea_path))
-        original_text = data["original_text"].to_s
-        if original_text.empty?
-          return [ flashed("idea has no original_text for #{row.slug}"), nil ]
+      def spawn_task_info_thread(row, request_id)
+        start_gate = Queue.new
+        thread = Thread.new do
+          start_gate.pop
+          info = @task_info_loader.call(row.folder)
+          @dispatch.call(Hive::Tui::Messages::TaskInfoLoaded.new(request_id: request_id, info: info))
+        rescue StandardError => e
+          text = Hive::Tui::Text.sanitize("#{e.class.name.split('::').last}: #{e.message}")[0, 160]
+          @dispatch.call(Hive::Tui::Messages::TaskInfoFailed.new(request_id: request_id, error: text))
+        ensure
+          @healed_folders_mutex.synchronize do
+            @heal_threads.delete(Thread.current)
+            @task_info_thread = nil if @task_info_thread == Thread.current
+          end
         end
-
-        capped_text = original_text[0, Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS]
-        [
-          @hive_model.with(
-            mode: :idea_preview,
-            idea_preview_text: capped_text,
-            idea_preview_slug: row.slug
-          ),
-          nil
-        ]
-      rescue Errno::ENOENT, Errno::EACCES, Psych::Exception
-        [ flashed("could not read idea for #{row.slug}"), nil ]
+        @healed_folders_mutex.synchronize do
+          @heal_threads << thread
+          @task_info_thread = thread
+        end
+        start_gate << true
+        thread
       end
 
-      def idea_frontmatter(contents)
-        match = contents.match(/\A---[ \t]*\r?\n(.*?)\r?\n---[ \t]*(?:\r?\n|\z)/m)
-        return {} unless match
+      def cancel_task_info_thread
+        thread = @healed_folders_mutex.synchronize { @task_info_thread }
+        return true unless thread&.alive?
 
-        parsed = YAML.safe_load(
-          match[1],
-          permitted_classes: [ Time, Date ],
-          permitted_symbols: [],
-          aliases: false
-        ) || {}
-        parsed.is_a?(Hash) ? parsed : {}
+        thread.kill
+        begin
+          thread.join(KILL_GRACE_SECONDS)
+        rescue StandardError
+          # A dead runner can make the worker's final dispatch raise.
+          # Dismissal still wins; the thread's ensure already pruned it.
+        end
+        !thread.alive?
       end
 
       def resolve_agent_label(row)
@@ -2884,11 +2910,6 @@ module Hive
         compose_two_pane_view(footer: prompt_footer(Views::FilterPrompt.render(@hive_model, width: usable), usable))
       end
 
-      def compose_idea_preview_view
-        usable = [ @hive_model.cols.to_i - 1, 1 ].max
-        compose_two_pane_view(footer: prompt_footer(Views::IdeaPreview.render(@hive_model, width: usable), usable))
-      end
-
       # New-idea mode: same composition; footer = the inline prompt with
       # the project label so the operator sees the resolved target.
       # Width clamps the prompt so long titles don't overflow the
@@ -3002,7 +3023,7 @@ module Hive
       # Default footer — context-aware key hints + flash decay (the
       # status line). v1 had this in Views::Grid#status_line; lifted here
       # so the panes stay layout-only. `usable_width` clamps the line
-      # so the fixed 75-char hint string doesn't overflow narrow
+      # so the fixed 79-char hint string doesn't overflow narrow
       # terminals (e.g. cols=70 used to wrap onto a second visible row).
       def default_footer(usable_width = nil)
         if @hive_model.flash_active?
@@ -3017,7 +3038,7 @@ module Hive
       end
 
       def footer_hint
-        "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [q] quit"
+        "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [i] info  [q] quit"
       end
 
       # Compute pane widths and join horizontally. Left pane is clamped
diff --git a/lib/hive/tui/key_map.rb b/lib/hive/tui/key_map.rb
index 8233e9a4..a05c56ad 100644
--- a/lib/hive/tui/key_map.rb
+++ b/lib/hive/tui/key_map.rb
@@ -88,7 +88,7 @@ module Hive
         when :red_status_detail then red_status_detail_message(key: key, row: row)
         when :filter then filter_message(key: key, row: row)
         when :help then help_message(key: key, row: row)
-        when :idea_preview then idea_preview_message(key: key, row: row)
+        when :task_info then task_info_message(key: key, row: row)
         when :new_idea_project then new_idea_project_message(key: key, row: row)
         when :new_idea then new_idea_message(key: key, row: row)
         else raise ArgumentError, "unknown mode: #{mode.inspect}"
@@ -135,7 +135,7 @@ module Hive
         # could fire any of these against a row whose cursor they are
         # not visually tracking.
         return Messages::OpenTaskFolder.new(row: row) if key == "o" && pane_focus == :right
-        return Messages::OpenIdeaPreview.new(row: row) if key == "i" && pane_focus == :right
+        return Messages::OpenTaskInfo.new(row: row) if key == "i" && pane_focus == :right
         return Messages::OpenInAgent.new(row: row) if key == "s" && pane_focus == :right
         return verb_message(row, key) if VERB_KEYS.key?(key)
         return enter_message(row) if ENTER_KEYS.include?(key)
@@ -402,11 +402,12 @@ module Hive
         Messages::BACK
       end
 
-      # Idea preview is read-only: every key closes it and returns to
-      # grid, whether Bubble Tea emitted a printable String or a
-      # special-key Symbol.
-      def idea_preview_message(key:, row:) # rubocop:disable Lint/UnusedMethodArgument
-        Messages::BACK
+      # Task info is deliberately modal and read-only. Only the three
+      # documented close gestures leave it; all other input is ignored.
+      def task_info_message(key:, row:) # rubocop:disable Lint/UnusedMethodArgument
+        return Messages::BACK if ESCAPE_KEYS.include?(key) || key == "q" || key == "i"
+
+        Messages::NOOP
       end
 
       # New-idea prompt mode — same key shape as `:filter` mode but
diff --git a/lib/hive/tui/log_tail.rb b/lib/hive/tui/log_tail.rb
index a997fd5d..57b6e6c2 100644
--- a/lib/hive/tui/log_tail.rb
+++ b/lib/hive/tui/log_tail.rb
@@ -154,13 +154,13 @@ module Hive
         # is empty so the render-mode boundary can short-circuit
         # back to grid with a flash message instead of opening an
         # empty viewer.
-        def latest(log_dir)
-          latest_in_dirs([ log_dir ])
+        def latest(log_dir, pattern: "*.log")
+          latest_in_dirs([ log_dir ], pattern: pattern)
         end
 
-        def latest_in_dirs(log_dirs)
+        def latest_in_dirs(log_dirs, pattern: "*.log")
           dirs = Array(log_dirs)
-          candidates = dirs.flat_map { |log_dir| Dir[File.join(log_dir.to_s, "*.log")] }
+          candidates = dirs.flat_map { |log_dir| Dir[File.join(log_dir.to_s, pattern)] }
           raise Hive::NoLogFiles, "no log files in #{dirs.join(', ')}" if candidates.empty?
 
           # `File.mtime` can race with concurrent log rotation that removes a
@@ -168,7 +168,7 @@ module Hive
           # let Errno::ENOENT crash the TUI.
           with_mtimes = candidates.filter_map do |path|
             [ path, File.mtime(path) ]
-          rescue Errno::ENOENT
+          rescue *FILESYSTEM_RESCUE
             nil
           end
           raise Hive::NoLogFiles, "no log files in #{dirs.join(', ')}" if with_mtimes.empty?
diff --git a/lib/hive/tui/messages.rb b/lib/hive/tui/messages.rb
index 980952a5..bdba230c 100644
--- a/lib/hive/tui/messages.rb
+++ b/lib/hive/tui/messages.rb
@@ -179,12 +179,21 @@ module Hive
       # (workflow-contextual) and the verb keys (subprocess dispatch).
       OpenTaskFolder = Data.define(:row)
 
-      # `i` in grid mode — read the focused row's source idea.md and
-      # show its original_text in the bottom strip. Carries the row so
-      # BubbleModel's side-effect handler can resolve `row.folder` at
-      # the moment of the keystroke; this cannot be a payload-free
-      # singleton because snapshot polling may move the live cursor.
-      OpenIdeaPreview = Data.define(:row)
+      # `i` in grid mode — open the read-only full-screen task information
+      # panel. KeyMap leaves request_id nil; BubbleModel assigns a unique
+      # identity before Update enters loading state and starts filesystem
+      # I/O. Carries the selected row so cursor movement or snapshot
+      # refreshes cannot retarget an in-flight request.
+      OpenTaskInfo = Data.define(:row, :request_id) do
+        def initialize(row:, request_id: nil)
+          super
+        end
+      end
+
+      # Immutable result messages dispatched by the tracked loader worker.
+      # Update accepts them only while the matching request is still open.
+      TaskInfoLoaded = Data.define(:request_id, :info)
+      TaskInfoFailed = Data.define(:request_id, :error)
 
       # `s` in grid mode — suspend the TUI and open the focused row's
       # configured development agent in the feature worktree. BubbleModel
diff --git a/lib/hive/tui/model.rb b/lib/hive/tui/model.rb
index b81a44c0..7965e98f 100644
--- a/lib/hive/tui/model.rb
+++ b/lib/hive/tui/model.rb
@@ -20,7 +20,7 @@ module Hive
     # Lifted out of the Data.define block because Ruby's Data.define
     # block-scope doesn't bind constants to the resulting class.
     Model = Data.define(
-      :mode,             # Symbol: :grid / :log_tail / :filter / :help / :new_idea_project / :new_idea / :idea_preview / :red_status_detail
+      :mode,             # Symbol selecting the active grid, prompt, or full-screen view
       :snapshot,         # Hive::Tui::Snapshot (or nil before first poll)
       :cursor,           # [project_idx, row_idx] (or nil for empty grid)
       :filter,           # String or nil — committed substring filter
@@ -40,8 +40,7 @@ module Hive
       # asset. Resets only on open / cancel / submit.
       :new_idea_attachment_counter,
       :new_idea_broken_labels, # Array<String> — labels highlighted after rich-submit validation fails
-      :idea_preview_text, # String or nil — original_text rendered in :idea_preview mode
-      :idea_preview_slug, # String or nil — slug captured when the preview opened
+      :task_info_state, # Model::TaskInfoState or nil — :task_info mode only
       :flash,            # String or nil — current status-line message
       :flash_set_at,     # Time or nil — flash decay timestamp
       :tail_state,       # Hive::Tui::LogTail::Tail or nil — :log_tail mode only
@@ -93,6 +92,11 @@ module Hive
       :log_lines,
       :log_scroll_offset
     )
+    Model::TaskInfoState = Data.define(:row, :request_id, :status, :info, :error) do
+      def initialize(row:, request_id:, status: :loading, info: nil, error: nil)
+        super
+      end
+    end
     # Single source of truth for the "no resolved label" copy. The
     # resolver in BubbleModel falls back to this string when project
     # config / agent lookup fails, so the view can render `agent_label`
@@ -128,8 +132,7 @@ module Hive
           new_idea_staging_tmp_root: nil,
           new_idea_attachment_counter: 0,
           new_idea_broken_labels: [],
-          idea_preview_text: nil,
-          idea_preview_slug: nil,
+          task_info_state: nil,
           flash: nil,
           flash_set_at: nil,
           tail_state: nil,
diff --git a/lib/hive/tui/task_info.rb b/lib/hive/tui/task_info.rb
new file mode 100644
index 00000000..ae13c5da
--- /dev/null
+++ b/lib/hive/tui/task_info.rb
@@ -0,0 +1,182 @@
+require "date"
+require "time"
+require "yaml"
+require "hive/task"
+require "hive/tui/log_tail"
+
+module Hive
+  module Tui
+    # Read-only filesystem snapshot used by the full-screen task info view.
+    # All reads happen on BubbleModel's tracked worker; Update and rendering
+    # only receive the frozen Snapshot value.
+    module TaskInfo
+      UNAVAILABLE = "unavailable".freeze
+      NONE = "none".freeze
+      EXECUTE_TAIL_LINES = 200
+
+      class LoadError < Hive::Error; end
+
+      Snapshot = Data.define(
+        :slug,
+        :stage,
+        :created_at,
+        :original_text,
+        :task_folder,
+        :latest_log_path,
+        :extra_label,
+        :extra_content,
+        :warnings,
+        :source_paths
+      ) do
+        def initialize(**attributes)
+          attributes = attributes.transform_values do |value|
+            case value
+            when String then value.dup.freeze
+            when Array then value.map { |item| item.is_a?(String) ? item.dup.freeze : item }.freeze
+            else value
+            end
+          end
+          super(**attributes)
+        end
+      end
+
+      module_function
+
+      def load(folder)
+        task = Hive::Task.new(folder)
+        ensure_current_folder!(task)
+        warnings = []
+        source_paths = []
+        idea = load_idea(task, warnings, source_paths)
+        latest_log_path = resolve_latest_log(task.log_dir, warnings)
+        source_paths << latest_log_path unless latest_log_path == NONE
+        extra_label, extra_content = load_extra(task, warnings, source_paths)
+        ensure_current_folder!(task)
+
+        Snapshot.new(
+          slug: task.slug,
+          stage: "#{task.stage_index}-#{task.stage_name}",
+          created_at: idea.fetch(:created_at),
+          original_text: idea.fetch(:original_text),
+          task_folder: task.folder,
+          latest_log_path: latest_log_path,
+          extra_label: extra_label,
+          extra_content: extra_content,
+          warnings: warnings,
+          source_paths: source_paths.uniq
+        )
+      rescue Hive::InvalidTaskPath => e
+        raise LoadError, "invalid task path: #{e.message}"
+      rescue StandardError => e
+        raise if e.is_a?(LoadError)
+
+        raise LoadError, "#{e.class.name.split('::').last}: #{e.message}"
+      end
+
+      def ensure_current_folder!(task)
+        return if File.directory?(task.folder)
+
+        raise LoadError, "task moved or disappeared while loading: #{task.folder}"
+      end
+
+      def load_idea(task, warnings, source_paths)
+        path = File.join(task.folder, "idea.md")
+        contents = read_optional(path, warnings, "idea")
+        return { created_at: UNAVAILABLE, original_text: UNAVAILABLE } if contents.nil?
+
+        source_paths << path
+        frontmatter, body = split_frontmatter(contents)
+        data = parse_frontmatter(frontmatter, warnings)
+        original = data["original_text"].to_s
+        original = body.to_s if original.empty?
+
+        {
+          created_at: format_created_at(data["created_at"]),
+          original_text: original.empty? ? UNAVAILABLE : original
+        }
+      end
+
+      def split_frontmatter(contents)
+        match = contents.match(/\A---[ \t]*\r?\n(.*?)\r?\n---[ \t]*(?:\r?\n|\z)/m)
+        return [ nil, contents ] unless match
+
+        [ match[1], contents[match.end(0)..].to_s ]
+      end
+
+      def parse_frontmatter(frontmatter, warnings)
+        return {} if frontmatter.nil?
+
+        parsed = YAML.safe_load(
+          frontmatter,
+          permitted_classes: [ Time, Date ],
+          permitted_symbols: [],
+          aliases: false
+        ) || {}
+        parsed.is_a?(Hash) ? parsed : {}
+      rescue Psych::Exception
+        warnings << "malformed idea frontmatter"
+        {}
+      end
+
+      def format_created_at(value)
+        return UNAVAILABLE if value.nil? || value.to_s.empty?
+        return value.utc.iso8601 if value.respond_to?(:utc) && value.respond_to?(:iso8601)
+
+        value.to_s
+      end
+
+      def resolve_latest_log(log_dir, warnings)
+        File.expand_path(LogTail::FileResolver.latest(log_dir))
+      rescue Hive::NoLogFiles
+        NONE
+      rescue *LogTail::FILESYSTEM_RESCUE, IOError => e
+        warnings << "latest log unavailable: #{e.class.name.split('::').last}"
+        NONE
+      end
+
+      def load_extra(task, warnings, source_paths)
+        case task.stage_name
+        when "brainstorm"
+          [ "Brainstorm", load_artifact(File.join(task.folder, "brainstorm.md"), warnings, source_paths) ]
+        when "plan"
+          [ "Plan", load_artifact(File.join(task.folder, "plan.md"), warnings, source_paths) ]
+        when "execute"
+          [ "Execute log", load_execute_tail(task.log_dir, warnings, source_paths) ]
+        else
+          [ nil, nil ]
+        end
+      end
+
+      def load_artifact(path, warnings, source_paths)
+        contents = read_optional(path, warnings, File.basename(path))
+        return UNAVAILABLE if contents.nil?
+
+        source_paths << path
+        contents
+      end
+
+      def load_execute_tail(log_dir, warnings, source_paths)
+        path = LogTail::FileResolver.latest(log_dir, pattern: "execute-*.log")
+        source_paths << File.expand_path(path)
+        tail = LogTail::Tail.new(path, ring_capacity: EXECUTE_TAIL_LINES)
+        tail.open!
+        tail.lines(EXECUTE_TAIL_LINES).join("\n")
+      rescue Hive::NoLogFiles
+        UNAVAILABLE
+      rescue *LogTail::FILESYSTEM_RESCUE, IOError => e
+        warnings << "execute log unavailable: #{e.class.name.split('::').last}"
+        UNAVAILABLE
+      ensure
+        tail&.close!
+      end
+
+      def read_optional(path, warnings, label)
+        contents = File.binread(path)
+        contents.force_encoding(Encoding::UTF_8).scrub("?")
+      rescue *LogTail::FILESYSTEM_RESCUE, IOError => e
+        warnings << "#{label} unavailable: #{e.class.name.split('::').last}"
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/tui/text.rb b/lib/hive/tui/text.rb
index 44b2c791..6d35b8ff 100644
--- a/lib/hive/tui/text.rb
+++ b/lib/hive/tui/text.rb
@@ -25,14 +25,22 @@ module Hive
 
       module_function
 
-      # Idempotent: strip ANSI CSI sequences first (so the trailing
-      # bytes do not survive into the second pass), then replace each
-      # remaining control byte with `?` so column-width math stays
-      # one-cell-per-character. nil/non-string input returns the empty
-      # string — every caller is concerned with display safety, not
-      # with surfacing a TypeError on a missing field.
+      # Idempotent: normalize invalid/undefined input bytes to UTF-8,
+      # strip ANSI CSI sequences (so their trailing bytes do not
+      # survive into the control pass), then replace each remaining
+      # control byte with `?` so column-width math stays one-cell-per-
+      # character. nil/non-string input returns the empty string —
+      # every caller is concerned with display safety, not with
+      # surfacing a TypeError on a missing field.
       def sanitize(text)
-        text.to_s.gsub(ANSI_CSI_PATTERN, "").gsub(CONTROL_CHARS_PATTERN, "?")
+        source = text.to_s.dup
+        if source.encoding == Encoding::ASCII_8BIT
+          source.force_encoding(Encoding::UTF_8)
+        else
+          source = source.encode(Encoding::UTF_8, invalid: :replace, undef: :replace, replace: "?")
+        end
+        source = source.scrub("?")
+        source.gsub(ANSI_CSI_PATTERN, "").gsub(CONTROL_CHARS_PATTERN, "?")
       end
     end
   end
diff --git a/lib/hive/tui/update.rb b/lib/hive/tui/update.rb
index f17a433b..1478f86b 100644
--- a/lib/hive/tui/update.rb
+++ b/lib/hive/tui/update.rb
@@ -75,6 +75,12 @@ module Hive
           [ apply_open_filter_prompt(model), nil ]
         when Messages::OpenRedStatusDetail
           [ apply_open_red_status_detail(model, message), nil ]
+        when Messages::OpenTaskInfo
+          [ apply_open_task_info(model, message), nil ]
+        when Messages::TaskInfoLoaded
+          [ apply_task_info_loaded(model, message), nil ]
+        when Messages::TaskInfoFailed
+          [ apply_task_info_failed(model, message), nil ]
         when Messages::RedStatusDetailScroll
           [ apply_red_status_detail_scroll(model, message), nil ]
         when Messages::Back
@@ -713,6 +719,33 @@ module Hive
         model.with(mode: :red_status_detail, red_status_detail_state: state)
       end
 
+      def apply_open_task_info(model, msg)
+        state = Model::TaskInfoState.new(row: msg.row, request_id: msg.request_id)
+        model.with(mode: :task_info, task_info_state: state)
+      end
+
+      def apply_task_info_loaded(model, msg)
+        state = matching_task_info_state(model, msg.request_id)
+        return model if state.nil?
+
+        model.with(task_info_state: state.with(status: :loaded, info: msg.info, error: nil))
+      end
+
+      def apply_task_info_failed(model, msg)
+        state = matching_task_info_state(model, msg.request_id)
+        return model if state.nil?
+
+        model.with(task_info_state: state.with(status: :failed, info: nil, error: msg.error.to_s))
+      end
+
+      def matching_task_info_state(model, request_id)
+        state = model.task_info_state
+        return nil unless model.mode == :task_info && state
+        return nil unless state.request_id == request_id
+
+        state
+      end
+
       def apply_red_status_detail_scroll(model, msg)
         state = model.red_status_detail_state
         if model.mode != :red_status_detail || state.nil?
@@ -782,7 +815,7 @@ end
           closed = model.with(mode: :grid, red_status_detail_state: nil)
           visible = visible_snapshot(closed)
           visible.nil? ? closed : closed.with(cursor: reclamp_cursor(visible, closed.cursor))
-        when :idea_preview then model.with(mode: :grid, idea_preview_text: nil, idea_preview_slug: nil)
+        when :task_info then close_task_info(model)
         when :help, :filter then model.with(mode: :grid)
         when :new_idea_project then apply_new_idea_cancelled(model)
         else model
@@ -793,6 +826,34 @@ end
         Array(model.snapshot&.projects).select { |project| project.error.nil? }
       end
 
+      def close_task_info(model)
+        selected_row = model.task_info_state&.row
+        closed = model.with(mode: :grid, task_info_state: nil)
+        visible = visible_snapshot(closed)
+        return closed if visible.nil?
+
+        selected_cursor = cursor_for_row(visible, selected_row)
+        closed.with(cursor: selected_cursor || reclamp_cursor(visible, closed.cursor))
+      end
+
+      def cursor_for_row(snapshot, selected_row)
+        return nil if selected_row.nil?
+
+        snapshot.projects.each_with_index do |project, project_idx|
+          folder_idx = project.rows.index { |row| row.folder == selected_row.folder }
+          return [ project_idx, folder_idx ] if folder_idx
+        end
+        snapshot.projects.each_with_index do |project, project_idx|
+          identity_idx = project.rows.index do |row|
+            row.project_name == selected_row.project_name &&
+              row.slug == selected_row.slug &&
+              row.stage == selected_row.stage
+          end
+          return [ project_idx, identity_idx ] if identity_idx
+        end
+        nil
+      end
+
       # `n == 0` clears scope (all projects). Out-of-range still flips
       # the scope (Snapshot returns an empty-projects view); cursor
       # resets to the first non-empty project or nil if the scoped grid
